#!BPY
""" Registration info for Blender menus
Name: 'ph_SymmetriseWeightsV2_1'
Blender: 231
Group: 'Misc'
Tooltip: 'Copy WeightsGroups from left to right or from right to left.'
"""
#### <> !

#################################
#                               #
#  ph_SymmetriseWeightsV2_1.py  #
#                               #
#      Cree le 29/12/2003       #
#                               #
#  par coolphil@worldonline.fr  #
#                               #
#      derniere mise a jour     #
#          le 09/05/2004        #
#								#
#################################

############ USAGE #############################
#
# Lancez le script (Alt-P)
#
# Passez EN MODE 'OBJET', choisissez le sens de la copie des Weights
# suivant le cas (bouton 'Left to Right') et appuyez sur le bouton 'Sym. Weights'.
# 
# Le script va se charger de reassigner vos 'Weights groups'
# 
#
# PS:
# ATTENTION, il est imperatif que vos Bones (ou Weights groups)
# qui sont symmetrique, aient strictement le meme nom (respect de la 'case')
# et que leurs terminaison soient (".L" et/ou ".R") ou ("_L" et/ou "_R").
#
# Exemple:
# "Bone_Leg.L" et "bone_Leg.R" => PAS CORRECT (a cause du 'B' et du 'b')
# "Bone_Leg.L" et "Bone_Leg.R" => CORRECT ('case' identique)
#
########################################################################

import Blender
from Blender import *
from Blender.Draw import *
from Blender.BGL import *

checksuffix = "."

drawYval = 0

SensFtoggle = Create(0)
drawtoggle = "Left to Right"

###############
def info_Obj():
###############

	Ob = []
	Obtype = 0
	mename = []
	me = []
	calque = 1

	if Object.GetSelected():
		Ob = Object.GetSelected()[0]
		if (Ob.getType() == 'Mesh'):

			Obtype = 1
			calque = Ob.Layer                    # Le "layer" de l'object selectionne
			mename = Ob.getData().name
			me = Ob.getData()

	return Ob,Obtype,mename,me

###################
def ClassVerts(me):
###################

		D_co_Verts = {} ### {[ABSco]: NMVerts, NMVert} (ou ...: [None], NMVert ou ...:NMVert, [None]) ####
		D_co_SymVtx = {} ### {[ABSco]: Position } (Position = 0 ou 1 (soit negatif ou positif)) ####
		L_Zero_coX = [] ### liste des NMVerts ayant zero comme coordonees X ####
		L_SelVerts = [] ### liste des vertex selectionnes ####
		L_Symsel = [] ### liste des symmetriques NMVerts a selectionnes ####

		#### Classement #########
		for v in me.verts:
			if abs(round(v.co[0],4)) == 0.0:
				L_Zero_coX.append(v)
			else:
				if v.co[0] < 0.0:
					pos = 0
				else:
					pos = 1

				x = abs(round(v.co[0],3))
				y = round(v.co[1],3)
				z = round(v.co[2],3)

				if pos:
					if D_co_Verts.has_key((x,y,z)):
						D_co_Verts[x,y,z] = D_co_Verts[x,y,z][0], v
					else:
						D_co_Verts[x,y,z] = (None), v
				else:
					if D_co_Verts.has_key((x,y,z)):
						tp = D_co_Verts[x,y,z][1]
						D_co_Verts[x,y,z] = v, tp
					else:
						D_co_Verts[x,y,z] = v, (None)

				if v.sel:
						L_SelVerts.append(v)
						D_co_SymVtx[x,y,z] = (pos == 0)
						L_Symsel.append((x,y,z))

		return D_co_Verts, D_co_SymVtx, L_Zero_coX, L_SelVerts, L_Symsel




############
def main():#
############
  global SensFtoggle, checksuffix

  Obj,Objtype,meshname,mesh = info_Obj()


  print "Obj =", Obj
  if Objtype:

          co_Verts, co_SymVtx, Zero_coX, SelVerts, Symsel = ClassVerts(mesh)

          ListGroup = mesh.getVertGroupNames()
#          print ListGroup

          MilieuGrp = []
          LeftGrp = []
          checkLeftGrp = []
          RightGrp = []
          checkRightGrp = []

          for gr in ListGroup:
#              done = ListGroup.index(gr)/float(len(ListGroup))
#              Window.DrawProgressBar(done, "Checking group!")
              if len(gr) > 1:
                  if gr[-2:] == ".L" or gr[-2:] == "_L":
                    if gr[-2:] == "_L":
                      checksuffix = "_"
                      LeftGrp.append(gr)
                      checkLeftGrp.append(gr[:-2])
                    else:
                      LeftGrp.append(gr)
                      checkLeftGrp.append(gr[:-2])
                  elif gr[-2:] == ".R" or gr[-2:] == "_R":
                    if gr[-2:] == "_R":
                      checksuffix = "_"
                      RightGrp.append(gr)
                      checkRightGrp.append(gr[:-2])
                    else:
                      RightGrp.append(gr)
                      checkRightGrp.append(gr[:-2])
                  else:
                      MilieuGrp.append(gr)
              else:
                  MilieuGrp.append(gr)

          checkLeftGrp.sort()
          checkRightGrp.sort()

#          print "MilieuGrp =", MilieuGrp
#          print "LeftGrp =", LeftGrp
#          print "RightGrp =", RightGrp
#          print "checkLeftGrp =", checkLeftGrp
#          print "checkRightGrp =", checkRightGrp

          if checkLeftGrp == checkRightGrp:

              if SensFtoggle.val == 0:

                  fromsuffix = checksuffix + "L"
                  tosuffix = checksuffix + "R"

              else:

                  fromsuffix = checksuffix + "R"
                  tosuffix = checksuffix + "L"

              for grname in checkLeftGrp:
#                 done = checkLeftGrp.index(grname)/float(len(checkLeftGrp))
#                 Window.DrawProgressBar(done, "Main process!")

                 fromname = grname + fromsuffix
                 toname = grname + tosuffix

                 print "from %s to %s"  %(fromname, toname),


                 grVerticesIndx = mesh.getVertsFromGroup(fromname,1)

                 if grVerticesIndx:

                     remVtx = mesh.getVertsFromGroup(toname,0)

                     mesh.removeVertsFromGroup(toname, remVtx)

                     for Pindx in grVerticesIndx:
                         indxP = Pindx[0]
                         weightP = Pindx[1]
#                         print "indxP =%s, weightP =%s" %(indxP, weightP)

                         Vtc = mesh.verts[indxP]

                         if (Vtc.co[0] > -0.0001) and (Vtc.co[0] < 0.0001):
                             sympos = 2
                             mesh.assignVertsToGroup(toname, [indxP], weightP, 'replace')

                         elif Vtc.co[0] < 0.0:
                             sympos = 1
                         elif Vtc.co[0] > 0.0:
                             sympos = 0

                         x = abs(round(Vtc.co[0],3))
                         y = round(Vtc.co[1],3)
                         z = round(Vtc.co[2],3)


                         if co_Verts.has_key((x, y, z)) and (sympos != 2):
                             symVtcIdx = mesh.verts.index(co_Verts[(x, y, z)][sympos])
                             mesh.assignVertsToGroup(toname, [symVtcIdx], weightP, 'replace')

                     print " ... OK."

          print "Finished !\a\r"

#          Window.DrawProgressBar(1, "Finished")

  return


############
def draw():#
############
  global SensFtoggle, drawYval, drawtoggle

  color1 = (0.99, 0.99, 0.65)
  color2 = (0.567, 0.476, 0.365)
  color2Clear = (0.567, 0.476, 0.365, 1)
  color3 = (1.0, 1.0, 0.79)
  color4 = (0.265, 0.41, 0.4)
  color4Clear = (0.265, 0.41, 0.4, 1)
  color5 = (0.4, 0.472, 0.472)
  color6 = (0.5, 0.25, 0.25)
  color7 = (0.265, 0.4, 0.3)
  colorblack = (0.0, 0.0, 0.0)
  colorwhite = (1.0, 1.0, 1.0)
  colorred = (1.0, 0.0, 0.0)
  colorcyan = (0.0, 1.0, 1.0)
  colorgrey1 = (0.8, 0.8, 0.8)


  apply(glClearColor, color4Clear)

  glClear(GL_COLOR_BUFFER_BIT)

  apply(glColor3f, colorblack)
  glRecti(1, 1, 260, 140 + drawYval)
  apply(glColor3f, colorgrey1)
  glRecti(1, 1, 259, 141 + drawYval)
  apply(glColor3f, color7)
  glRecti(1, 1, 259, 140 + drawYval)

  apply(glColor3f, colorblack)
  glRecti(1, 104 + drawYval, 259, 140 + drawYval)
  glColor3f(0.265, 0.35, 0.3)
  glRecti(1, 105 + drawYval, 259, 140 + drawYval)



  apply(glColor3f, colorblack)
  glRecti(1, 136 + drawYval, 190, 108 + drawYval)
  apply(glColor3f, colorgrey1)
  glRecti(1, 136 + drawYval, 189, 110 + drawYval)
  apply(glColor3f, color6)
  glRecti(1, 135 + drawYval, 189, 109 + drawYval)


  apply(glColor3f, colorwhite)
  glRasterPos2f(10, 120 + drawYval)
  Text("ph_SymmetriseWeightsV2_1.py")


  Button("Exit", 1, 210, 112 + drawYval, 40, 23, "Quit")

  Button("Sym. Weights", 2, 20, 40, 110, 35,"Symmetrise Weights.")

  SensFtoggle = Toggle(drawtoggle, 3, 155, 45, 85, 25, SensFtoggle.val, "Copy Weights from left to right or from right to left.")



######################
def event(evt, val): #
######################

    if ( evt == ESCKEY and not val): Exit()
    if (evt== QKEY and not val): Exit()



######################
def bevent(evt):     #
######################
    global Obj, mesh, ListGroup, drawtoggle, SensFtoggle


    if (evt== 1):
        Exit()

    if (evt== 2):
        print; print "Working..."
        main()

    if (evt== 3):
        if SensFtoggle.val == 1:
            drawtoggle = "Right to Left"
        else:
            drawtoggle = "Left to Right"


    Blender.Window.Redraw()

############

Register(draw, event, bevent)